declare type AnyObject = {
    [key: string]: any;
};
declare type ObjectObject = {
    [key: string]: object;
};
declare type NumberObject = {
    [key: string]: number;
};
declare type StringObject = {
    [key: string]: string;
};
declare type FunctionObject = {
    [key: string]: Function;
};
declare type Vector = {
    [key: string]: number;
};
declare type ReferencePair = [Object, string];
declare type Thenable = {
    then: Function;
};
declare type EBChild = string | number | Node | EBObject;
declare type EBTarget = Node | EBObject;
declare type ReferenceMap = Map<string, Object>;
declare type EventTuple = [string, EventListenerOrEventListenerObject, (boolean | EventListenerOptions)?];
declare type SetterCallback = (key: string, value: any) => void;
interface SetOptions {
    properties?: AnyObject | Function;
    attributes?: StringObject | Function;
    listeners?: EventTuple | EventTuple[] | Function;
    children?: EBChild | EBChild[] | Function;
}
interface IntoOptions {
    times?: number;
    at?: number;
}
interface EBObject {
    isEBuilder: boolean;
    readonly htmlContent: string;
    readonly el: Element;
    readonly element: Element;
    readonly children: NodeListOf<ChildNode>;
    readonly count: number;
    referenceMap: ReferenceMap;
    interval?: number;
    cloneList: Element[];
    getRef: (query: string) => any;
}
declare type RuleMap = Map<string, string>;
interface ProcessedEntry {
    key: string;
    value: any;
    rules: RuleMap;
}
interface ParsedObject {
    [key: string]: {
        value: any;
        rules: RuleMap;
        hasRules: () => boolean;
    };
}
declare module 'ebuilder-js' {
    const value: any;
    export default value;
}
